
# TOPDIR should be defined by the BUILD engine

# define the targets we can do - before including the Master template
LOCAL_TARGETS=all clean distclean install source save-config restore-config 
.PHONY: $(LOCAL_TARGETS)

# get the master definitions 
include $(TOPDIR)/BUILD/Master.mk

# remove cmd line set variables from interfering with the sub make
MAKEOVERRIDES=

ifdef CONFIG_BUILD_UBOOT
all install:: u-boot_build
else
all install:: 
endif

ifdef CONFIG_OMAP_17xx
CONFIG_NAME=omap1710h3_config
endif

ifdef CONFIG_OMAP_24xx
CONFIG_NAME=omap2420h4_config
endif

u-boot_build: $(IMAGEDIR)/u-boot-$(PRODUCTID).bin \
	$(HOSTDIR)/bin/mkimage

.PHONY: force_build
force_build: u-boot_make u-boot_build

include/config.mk:
ifdef CONFIG_NAME
	$(MAKE) $(CONFIG_NAME)
else
	$(error U-Boot doesn't support this build configuration)
endif

$(IMAGEDIR)/u-boot-$(PRODUCTID).bin: u-boot.bin
	@echo "*************************************"
	@echo "* Installing U-Boot"
	@echo "*************************************"
	$(INSTALL) $< $@

$(HOSTDIR)/bin/mkimage: tools/mkimage
	$(INSTALL) $< $@

u-boot_make u-boot.bin tools/mkimage: include/config.mk
	@echo "*************************************"
	@echo "* Building U-Boot"
	@echo "*************************************"
	$(MAKE) CROSS_COMPILE=$(CROSS)

# catch published sub-targets and call ourself with the force_ removed
$(LOCAL_TARGETS:%=force_%):
	@$(MAKE) -f .bld-adapter.mk TOPDIR=$(TOPDIR) $(@:force_%=%)

# call all direct targets and just pass blindly - after removing force_
force_%:
	$(MAKE) CROSS_COMPILE=$(CROSS) $(@:force_%=%)

# create a rule for the local targets.  Nothing to do, just pass them
# on to the master Makefile.
clean distclean::
	$(MAKE) $@

############################################################
# Release
############################################################

save-config::

restore-config::

source: $(RELEASEDIR) $(CONFSAVEDIR)
	$(call ReleaseCCFileList,.,U-Boot)
	$(call ReleasePkgCCsrc,.,U-Boot)

